#ifndef ZINK_DEVICE_INFO_H
#define ZINK_DEVICE_INFO_H

#include "util/u_memory.h"

#include <vulkan/vulkan.h>

struct zink_screen;

struct zink_device_info {
   uint32_t device_version;

   bool have_KHR_maintenance1;
   bool have_KHR_maintenance2;
   bool have_KHR_maintenance3;
   bool have_KHR_external_memory;
   bool have_KHR_external_memory_fd;
   bool have_EXT_external_memory_dma_buf;
   bool have_EXT_queue_family_foreign;
   bool have_EXT_provoking_vertex;
   bool have_EXT_shader_viewport_index_layer;
   bool have_KHR_get_memory_requirements2;
   bool have_EXT_post_depth_coverage;
   bool have_EXT_shader_subgroup_ballot;
   bool have_KHR_8bit_storage;
   bool have_KHR_16bit_storage;
   bool have_KHR_driver_properties;
   bool have_EXT_memory_budget;
   bool have_KHR_draw_indirect_count;
   bool have_EXT_fragment_shader_interlock;
   bool have_EXT_sample_locations;
   bool have_EXT_conservative_rasterization;
   bool have_KHR_shader_draw_parameters;
   bool have_KHR_sampler_mirror_clamp_to_edge;
   bool have_EXT_conditional_rendering;
   bool have_EXT_transform_feedback;
   bool have_EXT_index_type_uint8;
   bool have_KHR_imageless_framebuffer;
   bool have_EXT_robustness2;
   bool have_EXT_image_drm_format_modifier;
   bool have_EXT_vertex_attribute_divisor;
   bool have_EXT_calibrated_timestamps;
   bool have_KHR_shader_clock;
   bool have_EXT_sampler_filter_minmax;
   bool have_EXT_custom_border_color;
   bool have_EXT_blend_operation_advanced;
   bool have_EXT_extended_dynamic_state;
   bool have_EXT_extended_dynamic_state2;
   bool have_EXT_pipeline_creation_cache_control;
   bool have_EXT_shader_stencil_export;
#ifdef VK_EXTX_PORTABILITY_SUBSET_EXTENSION_NAME
   bool have_EXTX_portability_subset;
#endif
   bool have_KHR_timeline_semaphore;
   bool have_EXT_4444_formats;
   bool have_EXT_scalar_block_layout;
   bool have_KHR_swapchain;
   bool have_KHR_shader_float16_int8;
   bool have_EXT_multi_draw;
   bool have_KHR_push_descriptor;
   bool have_KHR_descriptor_update_template;
   bool have_EXT_line_rasterization;
   bool have_EXT_vertex_input_dynamic_state;
   bool have_EXT_primitive_topology_list_restart;
   bool have_KHR_dedicated_allocation;
   bool have_EXT_descriptor_indexing;
   bool have_vulkan11;
   bool have_vulkan12;

   VkPhysicalDeviceFeatures2 feats;
   VkPhysicalDeviceVulkan11Features feats11;
   VkPhysicalDeviceVulkan12Features feats12;

   VkPhysicalDeviceProperties props;
   VkPhysicalDeviceVulkan11Properties props11;
   VkPhysicalDeviceVulkan12Properties props12;

   VkPhysicalDeviceMemoryProperties mem_props;

   
   
   
   
   
   
   
   VkPhysicalDeviceProvokingVertexFeaturesEXT pv_feats;
   VkPhysicalDeviceProvokingVertexPropertiesEXT pv_props;
   
   
   
   
   VkPhysicalDevice8BitStorageFeaturesKHR storage_8bit_feats;
   VkPhysicalDevice16BitStorageFeaturesKHR storage_16bit_feats;
   VkPhysicalDeviceDriverPropertiesKHR driver_props;
   
   
   VkPhysicalDeviceFragmentShaderInterlockFeaturesEXT interlock_feats;
   VkPhysicalDeviceSampleLocationsPropertiesEXT sample_locations_props;
   VkPhysicalDeviceConservativeRasterizationPropertiesEXT cons_raster_props;
   
   
   VkPhysicalDeviceConditionalRenderingFeaturesEXT cond_render_feats;
   VkPhysicalDeviceTransformFeedbackFeaturesEXT tf_feats;
   VkPhysicalDeviceTransformFeedbackPropertiesEXT tf_props;
   VkPhysicalDeviceIndexTypeUint8FeaturesEXT index_uint8_feats;
   VkPhysicalDeviceImagelessFramebufferFeaturesKHR imgless_feats;
   VkPhysicalDeviceRobustness2FeaturesEXT rb2_feats;
   VkPhysicalDeviceRobustness2PropertiesEXT rb2_props;
   
   VkPhysicalDeviceVertexAttributeDivisorFeaturesEXT vdiv_feats;
   VkPhysicalDeviceVertexAttributeDivisorPropertiesEXT vdiv_props;
   
   VkPhysicalDeviceShaderClockFeaturesKHR shader_clock_feats;
   VkPhysicalDeviceSamplerFilterMinmaxPropertiesEXT reduction_props;
   VkPhysicalDeviceCustomBorderColorFeaturesEXT border_color_feats;
   VkPhysicalDeviceCustomBorderColorPropertiesEXT border_color_props;
   VkPhysicalDeviceBlendOperationAdvancedPropertiesEXT blend_props;
   VkPhysicalDeviceExtendedDynamicStateFeaturesEXT dynamic_state_feats;
   VkPhysicalDeviceExtendedDynamicState2FeaturesEXT dynamic_state2_feats;
   VkPhysicalDevicePipelineCreationCacheControlFeaturesEXT pipeline_cache_control_feats;
   
#ifdef VK_EXTX_PORTABILITY_SUBSET_EXTENSION_NAME
   VkPhysicalDevicePortabilitySubsetFeaturesEXTX portability_subset_extx_feats;
   VkPhysicalDevicePortabilitySubsetPropertiesEXTX portability_subset_extx_props;
#endif
   VkPhysicalDeviceTimelineSemaphoreFeaturesKHR timeline_feats;
   VkPhysicalDevice4444FormatsFeaturesEXT format_4444_feats;
   VkPhysicalDeviceScalarBlockLayoutFeaturesEXT scalar_block_layout_feats;
   
   VkPhysicalDeviceShaderFloat16Int8FeaturesKHR shader_float16_int8_feats;
   VkPhysicalDeviceMultiDrawFeaturesEXT multidraw_feats;
   VkPhysicalDeviceMultiDrawPropertiesEXT multidraw_props;
   VkPhysicalDevicePushDescriptorPropertiesKHR push_props;
   
   VkPhysicalDeviceLineRasterizationFeaturesEXT line_rast_feats;
   VkPhysicalDeviceLineRasterizationPropertiesEXT line_rast_props;
   VkPhysicalDeviceVertexInputDynamicStateFeaturesEXT vertex_input_feats;
   VkPhysicalDevicePrimitiveTopologyListRestartFeaturesEXT list_restart_feats;
   
   VkPhysicalDeviceDescriptorIndexingFeaturesEXT desc_indexing_feats;
   VkPhysicalDeviceDescriptorIndexingPropertiesEXT desc_indexing_props;

    const char *extensions[52];
    uint32_t num_extensions;
};

bool
zink_get_physical_device_info(struct zink_screen *screen);

void
zink_verify_device_extensions(struct zink_screen *screen);

/* stub functions that get inserted into the dispatch table if they are not
 * properly loaded.
 */
void zink_stub_TrimCommandPoolKHR(void);
void zink_stub_GetDescriptorSetLayoutSupportKHR(void);
void zink_stub_GetMemoryFdKHR(void);
void zink_stub_GetMemoryFdPropertiesKHR(void);
void zink_stub_GetImageMemoryRequirements2KHR(void);
void zink_stub_GetBufferMemoryRequirements2KHR(void);
void zink_stub_GetImageSparseMemoryRequirements2KHR(void);
void zink_stub_CmdDrawIndirectCountKHR(void);
void zink_stub_CmdDrawIndexedIndirectCountKHR(void);
void zink_stub_CmdSetSampleLocationsEXT(void);
void zink_stub_CmdBeginConditionalRenderingEXT(void);
void zink_stub_CmdEndConditionalRenderingEXT(void);
void zink_stub_CmdBindTransformFeedbackBuffersEXT(void);
void zink_stub_CmdBeginTransformFeedbackEXT(void);
void zink_stub_CmdEndTransformFeedbackEXT(void);
void zink_stub_CmdBeginQueryIndexedEXT(void);
void zink_stub_CmdEndQueryIndexedEXT(void);
void zink_stub_CmdDrawIndirectByteCountEXT(void);
void zink_stub_GetImageDrmFormatModifierPropertiesEXT(void);
void zink_stub_GetCalibratedTimestampsEXT(void);
void zink_stub_CmdSetCullModeEXT(void);
void zink_stub_CmdSetFrontFaceEXT(void);
void zink_stub_CmdSetPrimitiveTopologyEXT(void);
void zink_stub_CmdSetViewportWithCountEXT(void);
void zink_stub_CmdSetScissorWithCountEXT(void);
void zink_stub_CmdBindVertexBuffers2EXT(void);
void zink_stub_CmdSetDepthTestEnableEXT(void);
void zink_stub_CmdSetDepthWriteEnableEXT(void);
void zink_stub_CmdSetDepthCompareOpEXT(void);
void zink_stub_CmdSetDepthBoundsTestEnableEXT(void);
void zink_stub_CmdSetStencilTestEnableEXT(void);
void zink_stub_CmdSetStencilOpEXT(void);
void zink_stub_CmdSetPatchControlPointsEXT(void);
void zink_stub_CmdSetRasterizerDiscardEnableEXT(void);
void zink_stub_CmdSetDepthBiasEnableEXT(void);
void zink_stub_CmdSetLogicOpEXT(void);
void zink_stub_CmdSetPrimitiveRestartEnableEXT(void);
void zink_stub_GetSemaphoreCounterValueKHR(void);
void zink_stub_WaitSemaphoresKHR(void);
void zink_stub_SignalSemaphoreKHR(void);
void zink_stub_CreateSwapchainKHR(void);
void zink_stub_DestroySwapchainKHR(void);
void zink_stub_GetSwapchainImagesKHR(void);
void zink_stub_AcquireNextImageKHR(void);
void zink_stub_QueuePresentKHR(void);
void zink_stub_GetDeviceGroupPresentCapabilitiesKHR(void);
void zink_stub_GetDeviceGroupSurfacePresentModesKHR(void);
void zink_stub_AcquireNextImage2KHR(void);
void zink_stub_CmdDrawMultiEXT(void);
void zink_stub_CmdDrawMultiIndexedEXT(void);
void zink_stub_CmdPushDescriptorSetKHR(void);
void zink_stub_CmdPushDescriptorSetWithTemplateKHR(void);
void zink_stub_CmdPushDescriptorSetWithTemplateKHR(void);
void zink_stub_CreateDescriptorUpdateTemplateKHR(void);
void zink_stub_DestroyDescriptorUpdateTemplateKHR(void);
void zink_stub_UpdateDescriptorSetWithTemplateKHR(void);
void zink_stub_CmdPushDescriptorSetWithTemplateKHR(void);
void zink_stub_CmdSetLineStippleEXT(void);
void zink_stub_CmdSetVertexInputEXT(void);

#endif
